//**********************************************************************
// RhsAdminExec
// ============
//
// Client for RhsAdminSvc to run an application
//
// John Rennie
// jrennie@cix.compulink.co.uk
// 5th July 1998
//**********************************************************************

#ifndef STRICT
#define STRICT
#endif

#include <windows.h>
#include <stdio.h>
#include "RhsAdminSvc.h"

#include "GetLastErrorMessage.cpp"


//**********************************************************************
// Global variables
// ----------------
//**********************************************************************

#define SYNTAX "Syntax: RhsAdminExec <app [args]>\n"


//**********************************************************************
// main
// ----
//**********************************************************************

int main(int argc, char* argv[])
{ HANDLE h;
  DWORD d;
  char* p;
  char s[256];

// Some argument checking

  if (argc < 2)
  { printf(SYNTAX);
    return 2;
  }

// Get the command line excluding the app name
// NB this only works as long as our app name doesn't contain a space.  It
// won't do unless someone has renamed it.

  p = GetCommandLine();

  while (*p != ' ')
    p++;
  while (*p == ' ')
    p++;

  lstrcpy(s, "exec ");
  lstrcpyn(s + 5, p, 250);

// Write the app to the RhsAdminSvc service

  h = CreateFile(RHSADMINSVCPIPE, GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_EXISTING, 0, NULL);

  if (h == INVALID_HANDLE_VALUE)
  { printf("Cannot open connection to RhsAdminSvc:\n%s\n", GetLastErrorMessage());
    return 2;
  }

  WriteFile(h, s, lstrlen(s), &d, NULL);

// Read the response

  if (!ReadFile(h, s, 255, &d, NULL))
  { printf("Error reading response from RhsAdminSvc:\n%s\n", GetLastErrorMessage());
  }
  else
  { s[d] = '\0';
    printf("%s\n", s);
  }

  CloseHandle(h);

// All done

  return 0;
}
