//**********************************************************************
// RhsAdminSvc
// ===========
//**********************************************************************

#ifndef STRICT
#define STRICT
#endif

#include <windows.h>
#include "CNTService.h"
#include "CRhsAdminSvc.h"


//**********************************************************************
// Prototypes
// ----------
//**********************************************************************

int ParseCommandLine(int* argc, char* argv[]);


//**********************************************************************
// main
// ----
//**********************************************************************

int main(int argc, char* argv[])
{ int Argc;
  char* Argv[32];

// Create the service object

  CRhsAdminSvc MyService;

// Parse for standard arguments (install, uninstall, version etc.)

  ParseCommandLine(&Argc, Argv);

  if (!MyService.ParseStandardArgs(Argc, Argv))
  {

// Didn't find any standard args so start the service
// Uncomment the DebugBreak line below to enter the debugger
// when the service is started.
//DebugBreak();
    MyService.StartService();
  }

// When we get here, the service has been stopped

  return MyService.m_Status.dwWin32ExitCode;
}


//**********************************************************************
// ParseCommandLine
// ----------------
// This breaks up the command line to the usual argc/argv format.  The
// function is used to allow independance from the C run time library
// should I decide that is a good thing.
//**********************************************************************

int ParseCommandLine(int* argc, char* argv[])
{ char* ptr;
  char space;
  static char cmdline[256];

  lstrcpyn(cmdline, GetCommandLine(), 255);
  *argc = 0;
  ptr = cmdline;

  while (*ptr)
  { while (*ptr == ' ')
      ptr++;

    if (*ptr == '\"')
    { space = '\"';
      ptr++;
    }
    else
    { space = ' ';
    }

    argv[*argc] = ptr;

    while (*ptr != space && *ptr != '\0')
      ptr++;

    if (*ptr == space)
      *ptr++ = '\0';

    (*argc)++;
  }

  return(*argc);
}


